{ Das Programm QuadrGl mit der unit mathMohr
  Jetzt knne auch Brche eingeben werden.
  Die Lsungen knnen als Bruch dargestellt werden.
  Bei den Wurzeln ist der Nenner rational gemacht und es wird -falls mglich-
  teilweise radiziert.
}
unit Unit1;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Ea: TEdit;
    Label1: TLabel;
    Eb: TEdit;
    Label2: TLabel;
    Ec: TEdit;
    Label3: TLabel;
    Lx1: TLabel;
    Ex1: TEdit;
    Lx2: TLabel;
    Ex2: TEdit;
    LAnzahl: TLabel;
    EAnz: TEdit;
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EaChange(Sender: TObject);
    procedure EaKeyPress(Sender: TObject; var Key: Char);
    procedure EbKeyPress(Sender: TObject; var Key: Char);
    procedure EcKeyPress(Sender: TObject; var Key: Char);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type  Anzahl=0..2;
const MemoLoeschen=0;
      leicht = 'leicht';
      mittel = 'mittel';
      schwer = 'schwer';
      sehrschwer = 'sehr schwer';
      mitternachtsformel =
   '                Die "Mitternachtsformel"'#13#10+
   '                ========================'#13#10+
   '                 2'#13#10+
   'Die Gleichung ax + bx + c = 0 hat die Lsungen:'#13#10+
   #13#10+
   '                     2'#13#10+
   '         -b   sqrt(b  - 4ac)'#13#10+
   ' x    =   (sqrt = Wurzel)'#13#10+
   '  1,2             2a'#13#10#13#10+
   '       2'#13#10+
   '    d=b - 4ac heit Diskriminante.'#13#10+
   '    d<0: keine Lsungen'#13#10+
   '    d=0: eine Lsung'#13#10+
   '    d>0: zwei Lsungen'#13#10+
   #13#10+
   'Die "Mitternachtsformel" muss in Baden-Wrttemberg so fest'#13#10+
   'auswendig gelernt werden, dass sie selbst noch nach dem'#13#10+
   'Wecken aus dem Tiefschlaf auf Anhieb aufgesagt werden kann.';




var
  Form1: TForm1;

implementation

uses jmmath;
{$R *.DFM}

procedure zeigeFelder(n:Anzahl);
begin
  with form1 do Begin //da keine Methode von Form kennt die Prozedur Bx1 nicht
                      //sondern nur Form1.Bx1 u.s.w.
    CAse n of 0: BEGin
                   Lx1.hide;
                   Ex1.hide;
                   Lx2.hide;
                   Ex2.hide;
                 END;
              1: BEGin
                   Lx1.show;
                   Ex1.show;
                   Lx2.hide;
                   Ex2.hide;
                 END;
              2: BEGin
                   Lx1.show;
                   Ex1.show;
                   Lx2.show;
                   Ex2.show;
                 END;
    END; //zu jedem case ein end
  End;
end;


Procedure quadrGl(a,b,c:extended;var Anz:integer;var x1,x2:extended);
  var d,q:extended;
begin
  d:=b*b-4*a*c;
  if d<0 then Begin
    Anz:=0;
    ZeigeFelder(0)
  End else
    if d=0 then Begin
      Anz:=1;
      x1:=-b/2*a;
      ZeigeFelder(1);
    End else
    if d>0 then Begin
        Anz:=2;
        q:=sqrt(d);
        x1:=(-b+q)/(2*a);
        x2:=(-b-q)/(2*a);
        ZeigeFelder(2);
    end;
end;

function ausfuehrlichDarstellen(a,b,c,x:extended; vz:char):string;
  var d,t1,t2:extended; //muss nochmal gerechnet werden
      zeile:integer;
      x1,s,klammer:string;
begin
  if vz='+' then Begin
    zeile:=MemoLoeschen+2;
    x1:='x1';
  End else Begin
    zeile:=MemoLoeschen+3;
    x1:='x2';
  End;
  d:=b*b-4*a*c;
  t1:=-b;
  t2:=sqrt(d);
  s:=AlsWurzeloderPi(t2);
  if s='' then s:=floatToStr_(t2,18);
  form1.Memo1.Lines[zeile]:=x1+'=('+ReellZuGemZahl(t1)+vz+s+')/'+ReellZuGemZahl(abs(2*a));
  result:=ReellZuGemZahl(x);
  if (c = 0) and (vz <> '+') then Begin
    if a = 1 then klammer := '(x' else
      klammer :='('+ReellZuBruch(a)+'*x';
    if b>=0 then klammer := klammer + '+';
    klammer := klammer + ReellZuBruch(b)+ ') = 0';
    s := 'Besserer Lsungsweg: Lse x*'+klammer +#13#10+
    'Dann ist x=0 oder '+klammer;
    form1.Memo1.Lines[zeile+1] := s;
  End;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var Anz:integer;
      a,b,c,x1,x2:extended;
      s: string;
begin
    EaChange(Sender);
    a:=TermToReal(ea.text);
    b:=TermToReal(eb.text);
    c:=TermToReal(ec.text);
    quadrGl(a,b,c,Anz,x1,x2); //Nur wg. Anzahl
    eAnz.text:=IntToStr(Anz);
    LAnzahl.show;
    EAnz.show;
    form1.Memo1.Lines[MemoLoeschen]:='d='+ReellZuGemZahl(b*b-4*a*c);
    Case Anz of 0: form1.Memo1.Lines[MemoLoeschen+1]:='Keine reelle Lsung';
                1: BEgin
                     ex1.text:=ReellZuGemZahl(x1);
                     s := 'Kann mit der Binomischen Formel gerechnet werden'#13#10+
                       '(x';
                     if -x1>=0 then s := s+ '+';
                     s := s +   ReellZuGemZahl(-x1) + ')^2=0';
                     form1.Memo1.Lines[MemoLoeschen+1] := s;
                   ENd;
                2: BEgin
                     ex1.text:=ausfuehrlichDarstellen(a,b,c,x1,'+');
                     ex2.text:=ausfuehrlichDarstellen(a,b,c,x2,'-');
                   ENd;
    End;
    Ea.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;




//Im Enwurf auch Onchange fe Ex1 und Ex2 zuordnen
procedure TForm1.EaChange(Sender: TObject);
  var k:integer;
begin //Damit bei nderung keine falschen Ergebnisse dastehen
 LAnzahl.hide;
 EAnz.hide;
 zeigeFelder(0);
 for k:=MemoLoeschen to memo1.Lines.Count-1 do memo1.lines[k]:='';
end;

procedure TForm1.EaKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then eb.SetFocus; //#13 ist der ASCII-Code fr CR (EingabeTaste)
end;

procedure TForm1.EbKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then ec.SetFocus;
end;

procedure TForm1.EcKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then Begin
    ea.SetFocus;
    Button1Click(Sender);
  End;
end;

procedure diskriminanteNull(var a,b,c:real;const n:integer);
   var u,v:real;
begin
  //x1=u+isqrt(v) x2=u-isqrt(v)
  //(x-x1)*(x-x2) = (x-u)^2 + v^2 = x^2 - 2ux + u^2+v^2
  u := random(n);
  v := random(n);
  a := 1;
  b := -2*u;
  c := u*u + v*v;
end;

procedure liefereleicht(var a,b,c:real);
  var x1,x2:real;
begin
  if random < 1/4 then Begin
    diskriminanteNull(a,b,c,3);
    exit;
  End;
  x1 := random(10);
  x2 := random(10);
  a := 1;
  b := -(x1+x2);
  c := x1*x2;
end;

procedure verschiebe(var a,b,c:real; n:integer);
  var aa,bb,cc:real;
begin //statt ax^2+bx+c=0 a(x-1/n)^2 + b*(x-1/n) +c =0
 //ax^2      -2a/n*x + a*1/n^2 + bx   - b/n +c =0;
 //a*n^2x^2  -2anx   + a       +n^2bx -bn +c*n^2 =0
 aa := a*n*n;
 bb := -2*a*n + n*n*b;
 cc := a - b*n +c*n*n;
 a := aa;
 b := bb;
 c := cc;
end;


procedure lieferemittel(var a,b,c:real;const n:integer);
  var x1,x2:real;
begin
  if random < 1/4 then Begin
    diskriminanteNull(a,b,c,n);
    exit;
  End;
  x1 := random(20)-10;
  x2 := random(20)-10;
  a := 1;
  b := -(x1+x2);
  c := x1*x2;
  if (n>=3) and (random < 1/2) then c := c+1;
  verschiebe(a,b,c,random(n)+1);
end;


procedure TForm1.Button3Click(Sender: TObject);
  var a,b,c:real;
begin
  if button4.Caption = leicht then liefereleicht(a,b,c) else
    if button4.Caption = mittel then lieferemittel(a,b,c,3) else
       if button4.Caption = schwer then lieferemittel(a,b,c,6) else
          lieferemittel(a,b,c,9);
  Ea.text := ReellZuBruch(a);
  Eb.text := ReellZuBruch(b);
  Ec.text := ReellZuBruch(c);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  memo1.Text := Mitternachtsformel;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if button4.Caption = leicht then button4.caption := mittel else
     if button4.Caption = mittel  then button4.caption := schwer else
      if button4.Caption = schwer then button4.caption := sehrschwer else
        if button4.Caption = leicht then button4.caption := schwer else
           if button4.Caption = schwer then button4.caption := sehrschwer else
             button4.Caption := leicht;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Ea.Text := '-1/2';
  Eb.Text := '-1/7';
  Ec.Text := '-1';
  memo1.text := 'Du kannst das Programm auf zwei Arten verwenden:'#13#10#13#10+
                'I  Tippe die Koeffizienten a, b und c ein und'#13#10+
                '   schliee jede Eingabe mit der Eingabetaste ab.'#13#10+
                '   Dann wird Dir die Aufgabe vorgerechnet.'#13#10+
                '   (a,b und c drfen wie im Beispiel auch Brche sein!)'#13#10#13#10+
                'II ben der Mittenachtsformel'#13#10#13#10+
                'Lege Papier und Fller bereit!'#13#10+
                'Whle "leicht", "mittel", "schwer" oder "sehr schwer".'#13#10+
                '(Entsprechenden Knopf mehrmals klicken!)'#13#10+
                'Klicke "neue Aufgabe" und schreibe die Aufgabe ab!'#13#10+
                'Wenn Du fertig gerechnet hast, klicke "Berechne" an!'#13#10+
                'berprfe Dein Ergebnis und hake es ab bzw. suche'#13#10+
                'Deinen Fehler an Hand der Computerrechnung.'#13#10+
                '----------------------------------------------'#13#10+
                'Tipp: An drei Tagen in der Woche 20 Minuten gebt'#13#10+
                'ist besser als an einem Tag drei Stunden!'#13#10+
                '     Viel Spa mit dem Programm!'#13#10+
                '     (c) Joachim Mohr, 23.09.2001'#13#10+
                '     http://delphi.zsg-rottenburg.de';

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  memo1.text := Mitternachtsformel;
end;

end.
